Gio::TlsConnection Class Reference

TlsConnection - TLS connection type. More...

`#include <giomm/tlsconnection.h>`

Inheritance diagram for Gio::TlsConnection:
[legend]

## Public Member Functions

virtual | ~TlsConnection ()
GTlsConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GTlsConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GTlsConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_certificate (const Glib::RefPtr< TlsCertificate >& certificate)
| This sets the certificate that conn will present to its peer during the TLS handshake. More...
Glib::RefPtr< TlsCertificate > | get_certificate ()
| Gets conn's certificate, as set by g_tls_connection_set_certificate(). More...
Glib::RefPtr< const TlsCertificate > | get_certificate () const
| Gets conn's certificate, as set by g_tls_connection_set_certificate(). More...
TlsCertificateFlags | get_peer_certificate_errors () const
| Gets the errors associated with validating conn's peer's certificate, after the handshake has completed. More...
void | set_require_close_notify (bool require_close_notify)
| Sets whether or not conn expects a proper TLS close notification before the connection is closed. More...
bool | get_require_close_notify () const
| Tests whether or not conn expects a proper TLS close notification when the connection is closed. More...
void | set_rehandshake_mode (TlsRehandshakeMode mode)
| Sets how conn behaves with respect to rehandshaking requests. More...
TlsRehandshakeMode | get_rehandshake_mode () const
| Gets conn rehandshaking mode. More...
void | set_use_system_certdb (bool use_system_certdb)
| Sets whether conn uses the system certificate database to verify peer certificates. More...
bool | get_use_system_certdb () const
| Gets whether conn uses the system certificate database to verify peer certificates. More...
Glib::RefPtr< TlsDatabase > | get_database ()
| Gets the certificate database that conn uses to verify peer certificates. More...
Glib::RefPtr< const TlsDatabase > | get_database () const
| Gets the certificate database that conn uses to verify peer certificates. More...
void | set_database (const Glib::RefPtr< TlsDatabase >& database)
| Sets the certificate database that is used to verify peer certificates. More...
Glib::RefPtr< TlsInteraction > | get_interaction ()
| Get the object that will be used to interact with the user. More...
Glib::RefPtr< const TlsInteraction > | get_interaction () const
| Get the object that will be used to interact with the user. More...
void | set_interaction (const Glib::RefPtr< TlsInteraction >& interaction)
| Set the object that will be used to interact with the user. More...
bool | handshake (const Glib::RefPtr< Cancellable >& cancellable)
| Attempts a TLS handshake on conn. More...
bool | handshake ()
| A handshake() convenience overload. More...
void | handshake_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Asynchronously performs a TLS handshake on conn. More...
void | handshake_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| A handshake_async() convenience overload. More...
bool | handshake_finish (const Glib::RefPtr< AsyncResult >& result)
| Finish an asynchronous TLS handshake operation. More...
bool | emit_accept_certificate (const Glib::RefPtr< const TlsCertificate >& peer_cert, TlsCertificateFlags errors)
| Used by TlsConnection implementations to emit the TlsConnection::signal_accept_certificate() signal. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< IOStream > > | property_base_io_stream () const
| The GIOStream that the connection wraps. More...
Glib::PropertyProxy < Glib::RefPtr< TlsCertificate > > | property_certificate ()
| The connection's certificate. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< TlsCertificate > > | property_certificate () const
| The connection's certificate. More...
Glib::PropertyProxy < Glib::RefPtr< TlsDatabase > > | property_database ()
| Certificate database to use for looking up or verifying certificates. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< TlsDatabase > > | property_database () const
| Certificate database to use for looking up or verifying certificates. More...
Glib::PropertyProxy < Glib::RefPtr< TlsInteraction > > | property_interaction ()
| Optional object for user interaction. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< TlsInteraction > > | property_interaction () const
| Optional object for user interaction. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< TlsCertificate > > | property_peer_certificate () const
| The connection's peer's certificate. More...
Glib::PropertyProxy_ReadOnly < TlsCertificateFlags > | property_peer_certificate_errors () const
| Errors found with the peer's certificate. More...
Glib::PropertyProxy < TlsRehandshakeMode > | property_rehandshake_mode ()
| When to allow rehandshaking. More...
Glib::PropertyProxy_ReadOnly < TlsRehandshakeMode > | property_rehandshake_mode () const
| When to allow rehandshaking. More...
Glib::PropertyProxy< bool > | property_require_close_notify ()
| Whether to require proper TLS close notification. More...
Glib::PropertyProxy_ReadOnly < bool > | property_require_close_notify () const
| Whether to require proper TLS close notification. More...
Glib::PropertyProxy< bool > | property_use_system_certdb ()
| Whether to verify peer certificates against the system certificate database. More...
Glib::PropertyProxy_ReadOnly < bool > | property_use_system_certdb () const
| Whether to verify peer certificates against the system certificate database. More...
Glib::SignalProxy2< bool, const Glib::RefPtr< const TlsCertificate > &, TlsCertificateFlags > | signal_accept_certificate ()
virtual bool | handshake_vfunc (const Glib::RefPtr< Cancellable >& cancellable)
virtual void | handshake_async_vfunc (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority)
virtual bool | handshake_finish_vfunc (const Glib::RefPtr< AsyncResult >& result)
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions

| TlsConnection ()
virtual bool | on_accept_certificate (const Glib::RefPtr< const TlsCertificate >& peer_cert, TlsCertificateFlags errors)
| This is a default handler for the signal signal_accept_certificate(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gio::TlsConnection > | wrap (GTlsConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members

Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

TlsConnection - TLS connection type.

TlsConnection is the base TLS connection class type, which wraps an IOStream and provides TLS encryption on top of it. Its subclasses, TlsClientConnection and TlsServerConnection, implement client-side and server-side TLS, respectively.

Since glibmm 2.36:

## Constructor & Destructor Documentation

virtual Gio::TlsConnection::~TlsConnection | ( |  | ) |

virtual

Gio::TlsConnection::TlsConnection | ( |  | ) |

protected

## Member Function Documentation

bool Gio::TlsConnection::emit_accept_certificate | ( | const Glib::RefPtr< const TlsCertificate >& | peer_cert,
|  | TlsCertificateFlags | errors
| ) |  |

Used by TlsConnection implementations to emit the TlsConnection::signal_accept_certificate() signal.

Since glibmm 2.28:

Parameters

  peer_cert | The peer's TlsCertificate.
  errors | The problems with peer_cert.

Returns
  `true` if one of the signal handlers has returned `true` to accept peer_cert.

Glib::RefPtr<TlsCertificate> Gio::TlsConnection::get_certificate | ( |  | ) |

Gets conn's certificate, as set by g_tls_connection_set_certificate().

Since glibmm 2.28:

Returns
  conn's certificate, or `0`.

Glib::RefPtr<const TlsCertificate> Gio::TlsConnection::get_certificate | ( |  | ) | const

Gets conn's certificate, as set by g_tls_connection_set_certificate().

Since glibmm 2.28:

Returns
  conn's certificate, or `0`.

Glib::RefPtr<TlsDatabase> Gio::TlsConnection::get_database | ( |  | ) |

Gets the certificate database that conn uses to verify peer certificates.

See g_tls_connection_set_database().

Since glibmm 2.30:

Returns
  The certificate database that conn uses or `0`.

Glib::RefPtr<const TlsDatabase> Gio::TlsConnection::get_database | ( |  | ) | const

Gets the certificate database that conn uses to verify peer certificates.

See g_tls_connection_set_database().

Since glibmm 2.30:

Returns
  The certificate database that conn uses or `0`.

Glib::RefPtr<TlsInteraction> Gio::TlsConnection::get_interaction | ( |  | ) |

Get the object that will be used to interact with the user.

It will be used for things like prompting the user for passwords. If `0` is returned, then no user interaction will occur for this connection.

Since glibmm 2.30:

Returns
  The interaction object.

Glib::RefPtr<const TlsInteraction> Gio::TlsConnection::get_interaction | ( |  | ) | const

Get the object that will be used to interact with the user.

It will be used for things like prompting the user for passwords. If `0` is returned, then no user interaction will occur for this connection.

Since glibmm 2.30:

Returns
  The interaction object.

TlsCertificateFlags Gio::TlsConnection::get_peer_certificate_errors | ( |  | ) | const

Gets the errors associated with validating conn's peer's certificate, after the handshake has completed.

(It is not set during the emission of TlsConnection::signal_accept_certificate().)

Since glibmm 2.28:

Returns
  conn's peer's certificate errors.

TlsRehandshakeMode Gio::TlsConnection::get_rehandshake_mode | ( |  | ) | const

Gets conn rehandshaking mode.

See g_tls_connection_set_rehandshake_mode() for details.

Since glibmm 2.28:

Returns
  conn's rehandshaking mode.

bool Gio::TlsConnection::get_require_close_notify | ( |  | ) | const

Tests whether or not conn expects a proper TLS close notification when the connection is closed.

See g_tls_connection_set_require_close_notify() for details.

Since glibmm 2.28:

Returns
  `true` if conn requires a proper TLS close notification.

static GType Gio::TlsConnection::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

bool Gio::TlsConnection::get_use_system_certdb | ( |  | ) | const

Gets whether conn uses the system certificate database to verify peer certificates.

See g_tls_connection_set_use_system_certdb().

Deprecated: 2.30: Use g_tls_connection_get_database() instead

Returns
  Whether conn uses the system certificate database.

GTlsConnection* Gio::TlsConnection::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GTlsConnection* Gio::TlsConnection::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GTlsConnection* Gio::TlsConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::TlsConnection::handshake | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Attempts a TLS handshake on conn.

On the client side, it is never necessary to call this method; although the connection needs to perform a handshake after connecting (or after sending a "STARTTLS"-type command) and may need to rehandshake later if the server requests it, TlsConnection will handle this for you automatically when you try to send or receive data on the connection. However, you can call g_tls_connection_handshake() manually if you want to know for sure whether the initial handshake succeeded or failed (as opposed to just immediately trying to write to conn's output stream, in which case if it fails, it may not be possible to tell if it failed before or after completing the handshake).

Likewise, on the server side, although a handshake is necessary at the beginning of the communication, you do not need to call this function explicitly unless you want clearer error reporting. However, you may call g_tls_connection_handshake() later on to renegotiate parameters (encryption methods, etc) with the client.

TlsConnection::accept_certificate may be emitted during the handshake.

Since glibmm 2.28:

Parameters

  cancellable | A Cancellable, or `0`.

Returns
  Success or failure.

bool Gio::TlsConnection::handshake | ( |  | ) |

A handshake() convenience overload.

void Gio::TlsConnection::handshake_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

Asynchronously performs a TLS handshake on conn.

See g_tls_connection_handshake() for more information.

Since glibmm 2.28:

Parameters

  io_priority | The I/O priority of the request.
  cancellable | A Cancellable, or `0`.
  slot | Callback to call when the handshake is complete.

void Gio::TlsConnection::handshake_async | ( | const SlotAsyncReady& | slot,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

A handshake_async() convenience overload.

virtual void Gio::TlsConnection::handshake_async_vfunc | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority
| ) |  |

virtual

bool Gio::TlsConnection::handshake_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Finish an asynchronous TLS handshake operation.

See g_tls_connection_handshake() for more information.

Since glibmm 2.28:

Parameters

  result | A AsyncResult.

Returns
  `true` on success, `false` on failure, in which case error will be set.

virtual bool Gio::TlsConnection::handshake_finish_vfunc | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

virtual

Exceptions

  Glib::Error. |

virtual bool Gio::TlsConnection::handshake_vfunc | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

virtual

Exceptions

  Glib::Error. |

virtual bool Gio::TlsConnection::on_accept_certificate | ( | const Glib::RefPtr< const TlsCertificate >& | peer_cert,
|  | TlsCertificateFlags | errors
| ) |  |

protectedvirtual

This is a default handler for the signal signal_accept_certificate().

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<IOStream> > Gio::TlsConnection::property_base_io_stream | ( |  | ) | const

The GIOStream that the connection wraps.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<TlsCertificate> > Gio::TlsConnection::property_certificate | ( |  | ) |

The connection's certificate.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsCertificate> > Gio::TlsConnection::property_certificate | ( |  | ) | const

The connection's certificate.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<TlsDatabase> > Gio::TlsConnection::property_database | ( |  | ) |

Certificate database to use for looking up or verifying certificates.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsDatabase> > Gio::TlsConnection::property_database | ( |  | ) | const

Certificate database to use for looking up or verifying certificates.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Glib::RefPtr<TlsInteraction> > Gio::TlsConnection::property_interaction | ( |  | ) |

Optional object for user interaction.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsInteraction> > Gio::TlsConnection::property_interaction | ( |  | ) | const

Optional object for user interaction.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<TlsCertificate> > Gio::TlsConnection::property_peer_certificate | ( |  | ) | const

The connection's peer's certificate.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< TlsCertificateFlags > Gio::TlsConnection::property_peer_certificate_errors | ( |  | ) | const

Errors found with the peer's certificate.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< TlsRehandshakeMode > Gio::TlsConnection::property_rehandshake_mode | ( |  | ) |

When to allow rehandshaking.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< TlsRehandshakeMode > Gio::TlsConnection::property_rehandshake_mode | ( |  | ) | const

When to allow rehandshaking.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gio::TlsConnection::property_require_close_notify | ( |  | ) |

Whether to require proper TLS close notification.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gio::TlsConnection::property_require_close_notify | ( |  | ) | const

Whether to require proper TLS close notification.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gio::TlsConnection::property_use_system_certdb | ( |  | ) |

Whether to verify peer certificates against the system certificate database.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gio::TlsConnection::property_use_system_certdb | ( |  | ) | const

Whether to verify peer certificates against the system certificate database.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gio::TlsConnection::set_certificate | ( | const Glib::RefPtr< TlsCertificate >& | certificate | ) |

This sets the certificate that conn will present to its peer during the TLS handshake.

For a TlsServerConnection, it is mandatory to set this, and that will normally be done at construct time.

For a TlsClientConnection, this is optional. If a handshake fails with TLS_ERROR_CERTIFICATE_REQUIRED, that means that the server requires a certificate, and if you try connecting again, you should call this method first. You can call g_tls_client_connection_get_accepted_cas() on the failed connection to get a list of Certificate Authorities that the server will accept certificates from.

(It is also possible that a server will allow the connection with or without a certificate; in that case, if you don't provide a certificate, you can tell that the server requested one by the fact that g_tls_client_connection_get_accepted_cas() will return non-`0`.)

Since glibmm 2.28:

Parameters

  certificate | The certificate to use for conn.

void Gio::TlsConnection::set_database | ( | const Glib::RefPtr< TlsDatabase >& | database | ) |

Sets the certificate database that is used to verify peer certificates.

This is set to the default database by default. See g_tls_backend_get_default_database(). If set to `0`, then peer certificate validation will always set the TLS_CERTIFICATE_UNKNOWN_CA error (meaning TlsConnection::signal_accept_certificate() will always be emitted on client-side connections, unless that bit is not set in TlsClientConnection::property_validation_flags()).

Since glibmm 2.30:

Parameters

  database | A TlsDatabase.

void Gio::TlsConnection::set_interaction | ( | const Glib::RefPtr< TlsInteraction >& | interaction | ) |

Set the object that will be used to interact with the user.

It will be used for things like prompting the user for passwords.

The interaction argument will normally be a derived subclass of TlsInteraction. `0` can also be provided if no user interaction should occur for this connection.

Since glibmm 2.30:

Parameters

  interaction | An interaction object, or `0`.

void Gio::TlsConnection::set_rehandshake_mode | ( | TlsRehandshakeMode | mode | ) |

Sets how conn behaves with respect to rehandshaking requests.

TLS_REHANDSHAKE_NEVER means that it will never agree to rehandshake after the initial handshake is complete. (For a client, this means it will refuse rehandshake requests from the server, and for a server, this means it will close the connection with an error if the client attempts to rehandshake.)

TLS_REHANDSHAKE_SAFELY means that the connection will allow a rehandshake only if the other end of the connection supports the TLS `renegotiation_info` extension. This is the default behavior, but means that rehandshaking will not work against older implementations that do not support that extension.

TLS_REHANDSHAKE_UNSAFELY means that the connection will allow rehandshaking even without the `renegotiation_info` extension. On the server side in particular, this is not recommended, since it leaves the server open to certain attacks. However, this mode is necessary if you need to allow renegotiation with older client software.

Since glibmm 2.28:

Parameters

  mode | The rehandshaking mode.

void Gio::TlsConnection::set_require_close_notify | ( | bool | require_close_notify | ) |

Sets whether or not conn expects a proper TLS close notification before the connection is closed.

If this is `true` (the default), then conn will expect to receive a TLS close notification from its peer before the connection is closed, and will return a TLS_ERROR_EOF error if the connection is closed without proper notification (since this may indicate a network error, or man-in-the-middle attack).

In some protocols, the application will know whether or not the connection was closed cleanly based on application-level data (because the application-level data includes a length field, or is somehow self-delimiting); in this case, the close notify is redundant and sometimes omitted. (TLS 1.1 explicitly allows this; in TLS 1.0 it is technically an error, but often done anyway.) You can use g_tls_connection_set_require_close_notify() to tell conn to allow an "unannounced" connection close, in which case the close will show up as a 0-length read, as in a non-TLS SocketConnection, and it is up to the application to check that the data has been fully received.

Note that this only affects the behavior when the peer closes the connection; when the application calls g_io_stream_close() itself on conn, this will send a close notification regardless of the setting of this property. If you explicitly want to do an unclean close, you can close conn's TlsConnection::property_base_io_stream() rather than closing conn itself.

Since glibmm 2.28:

Parameters

  require_close_notify | Whether or not to require close notification.

void Gio::TlsConnection::set_use_system_certdb | ( | bool | use_system_certdb | ) |

Sets whether conn uses the system certificate database to verify peer certificates.

This is `true` by default. If set to `false`, then peer certificate validation will always set the TLS_CERTIFICATE_UNKNOWN_CA error (meaning TlsConnection::signal_accept_certificate() will always be emitted on client-side connections, unless that bit is not set in TlsClientConnection::property_validation_flags()).

Deprecated: 2.30: Use g_tls_connection_set_database() instead

Parameters

  use_system_certdb | Whether to use the system certificate database.

Glib::SignalProxy2< bool,const Glib::RefPtr<const TlsCertificate>&,TlsCertificateFlags > Gio::TlsConnection::signal_accept_certificate | ( |  | ) |

Slot Prototype:
  `bool on_my_accept_certificate(const Glib::RefPtr<const TlsCertificate>& peer_cert, TlsCertificateFlags errors)`

Emitted during the TLS handshake after the peer certificate has been received. You can examine peer_cert's certification path by calling g_tls_certificate_get_issuer() on it.

For a client-side connection, peer_cert is the server's certificate, and the signal will only be emitted if the certificate was not acceptable according to conn's TlsClientConnection::property_validation()_flags. If you would like the certificate to be accepted despite errors, return `true` from the signal handler. Otherwise, if no handler accepts the certificate, the handshake will fail with TLS_ERROR_BAD_CERTIFICATE.

For a server-side connection, peer_cert is the certificate presented by the client, if this was requested via the server's TlsServerConnection::property_authentication()_mode. On the server side, the signal is always emitted when the client presents a certificate, and the certificate will only be accepted if a handler returns `true`.

Note that if this signal is emitted as part of asynchronous I/O in the main thread, then you should not attempt to interact with the user before returning from the signal handler. If you want to let the user decide whether or not to accept the certificate, you would have to return `false` from the signal handler on the first attempt, and then after the connection attempt returns a TLS_ERROR_HANDSHAKE, you can interact with the user, and if the user decides to accept the certificate, remember that fact, create a new connection, and return `true` from the signal handler the next time.

If you are doing I/O in another thread, you do not need to worry about this, and can simply block in the signal handler until the UI thread returns an answer.

Since glibmm 2.28:

Parameters

  peer_cert | The peer's TlsCertificate.
  errors | The problems with peer_cert.

Returns
  `true` to accept peer_cert (which will also immediately end the signal emission). `false` to allow the signal emission to continue, which will cause the handshake to fail if no one else overrides it.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::TlsConnection > wrap | ( | GTlsConnection * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.